<?php

namespace STM\Competition\Season;

use \GetterOfTestingInstances;
use \Exception;
use STM\StmFactory;

/**
 * Test class for SeasonValidator.
 * Generated by PHPUnit on 2012-02-10 at 18:41:59.
 * @group competition_season
 */
class SeasonValidatorTest extends \PHPUnit_Framework_TestCase {

    /** @var Season */
    private $season;

    protected function setUp() {
        $this->season = GetterOfTestingInstances::get_season();
        SeasonValidator::init();
        SeasonValidator::resetSeason();
    }

    public function testCheck_create() {
        // it must be array with defined key
        $this->assert_bad_value('checkCreate', null);
        $this->assert_bad_value('checkCreate', new Exception());
        $this->assert_bad_value('checkCreate', array('season_periods', 'point_win', 'point_win_ot', 'point_draw', 'point_loss_ot', 'point_loss'));        
        // point integrity >=
        $this->assert_bad_value('checkCreate', array('season_periods' => 2, 'point_win' => 0, 'point_win_ot' => 2, 'point_draw' => 1, 'point_loss_ot' => 0, 'point_loss' => 0));        
        
        $this->assert_good_value('checkCreate', array('season_periods' => 2, 'point_win' => 2, 'point_win_ot' => 2, 'point_draw' => 1, 'point_loss_ot' => 0, 'point_loss' => 0));        
    }

    public function testCheck_update() {
        foreach (GetterOfTestingInstances::find_seasons() as $season) {
            SeasonValidator::setSeason($season);
            $arr =  $season->toArray();
            $valid = array(
                'season_periods' => $arr['season_periods'], 
                'point_win' =>  $arr['points']['win'], 
                'point_win_ot' =>  $arr['points']['win_overtime'], 
                'point_draw' =>  $arr['points']['draw'], 
                'point_loss_ot' =>  $arr['points']['loss_overtime'], 
                'point_loss' =>  $arr['points']['loss'], 
            );
            // different from current name and club
            $this->assert_bad_value('checkUpdate', $valid);
            
            // WIN >= WIN IN OVERTIME >= DRAW >= LOSS IN OT >= LOSS
            if ($valid['point_win'] != $valid['point_loss']) {
                $integrity = $valid;
                $integrity['point_win'] = $valid['point_loss'];
                $this->assert_bad_value('checkUpdate', $integrity);
            }
            
            // at least one change (in name or club)
            $valid['season_periods'] += 1;
            parent::assertTrue(SeasonValidator::checkUpdate($valid));
            
            SeasonValidator::resetSeason();
        }
    }

    public function testCheck_season_periods() {
        $this->assert_good_value('checkSeasonPeriods', 1);
        $this->assert_good_value('checkSeasonPeriods', 7);
        $this->assert_good_value('checkSeasonPeriods', 10);
        // it must be int <1,20>
        $this->assert_bad_value('checkSeasonPeriods', null);
        $this->assert_bad_value('checkSeasonPeriods', 0);
        $this->assert_bad_value('checkSeasonPeriods', 21);
    }

    public function testCheck_point_win() {
        $this->assert_point('checkPointWin');
    }

    public function testCheck_point_win_ot() {
        $this->assert_point('checkPointWinOt');
    }

    public function testCheck_point_draw() {
        $this->assert_point('checkPointDraw');
    }

    public function testCheck_point_loss_ot() {
        $this->assert_point('checkPointLossOt');
    }

    public function testCheck_point_loss() {
        $this->assert_point('checkPointLoss');
    }

    public function testCheck_extra_points() {
        // season must be set
        parent::assertFalse(SeasonValidator::checkExtraPoints(StmFactory::find()->Team->findById(1), 5));
        
        if (!$this->season) {
            return;
        }
        
        SeasonValidator::setSeason($this->season);
        foreach ($this->season->getTeams() as $team) {
            SeasonValidator::init();
            parent::assertTrue(SeasonValidator::checkExtraPoints($team, 1));
            parent::assertTrue(SeasonValidator::checkExtraPoints($team, -1));
            // points must be <-20,20> but no 0
            SeasonValidator::init();
            parent::assertFalse(SeasonValidator::checkExtraPoints($team, -21));
            SeasonValidator::init();
            parent::assertFalse(SeasonValidator::checkExtraPoints($team, 21));
            SeasonValidator::init();
            parent::assertFalse(SeasonValidator::checkExtraPoints($team, 0));
        }
        
        foreach(StmFactory::find()->Team->findAll() as $team) {
            // team must be from seaosn
            if (!$this->season->isTeamFromCompetition($team)) {
                SeasonValidator::init();
                parent::assertFalse(SeasonValidator::checkExtraPoints($team, 1));
            }
        }
    }

    private function assert_point($method) {
        SeasonValidator::init();
        SeasonValidator::resetSeason();
        $this->assert_good_value($method, -20);
        $this->assert_good_value($method, 0);
        $this->assert_good_value($method, 20);
        // it must be int <-20,20>
        $this->assert_bad_value($method, null);
        $this->assert_bad_value($method, -21);
        $this->assert_bad_value($method, 21);
    }

    private function assert_bad_value($method, $value) {
        SeasonValidator::init();
        parent::assertFalse(SeasonValidator::$method($value));
        SeasonValidator::init();
    }

    private function assert_good_value($method, $value) {
        SeasonValidator::init();
        parent::assertTrue(SeasonValidator::$method($value));
    }

}

?>
